Index: applications/doprava/texty/novotny_vyzk_LQ/Implementation.tex.backup
===================================================================
--- applications/doprava/texty/novotny_vyzk_LQ/Implementation.tex.backup (revision 1419)
+++ applications/doprava/texty/novotny_vyzk_LQ/Implementation.tex.backup (revision 1424)
@@ -32,10 +32,10 @@
 méně než 3,6 km/h. Pro danou frontu v čase $t+1$ platí zřejmě vztah
 \begin{equation}\label{eq:my_trans_01}
- q_j(t+1) = q_j(t) + T ( i_j(t) - o_j(t) )
-\end{equation}, kde hustota vstupu $i_j(t)$ je součtem výstupů sousedů pronásobený odbočovacími poměry,
+ q_j(t+1) = q_j(t) + T ( i_j(t) - o_j(t) ) , 
+\end{equation}kde hustota vstupu $i_j(t)$ je součtem výstupů sousedů pronásobený odbočovacími poměry,
 případně vstupu do systému $i_{j,0}(t)$, pokud se jedná o koncové rameno řízené oblasti, tedy
 \begin{equation}
-  i_j(t) = i_{j,0}(t) + \sum_{k \in I_j} \alpha_{k,j} o_k(t)
-\end{equation}.
+  i_j(t) = i_{j,0}(t) + \sum_{k \in I_j} \alpha_{k,j} o_k(t) .
+\end{equation}
 Křižovtkou z daného jízdního pruhu v průjezdné fázi projede $S$ vozidel za sekundu, kde 
 délka průjezdné fáze závisí na nastaveném poměru a délce cyklu. Před přechodem do nové
@@ -47,21 +47,38 @@
 a pro hustotu výstupu platí
 \begin{equation}
- o_j(t) = \frac{S_j g_j(t)}{C(t)} = S_j g_j^N \left( 1 - LC(t)^{-1} \right)
-\end{equation}. Rovnice \ref{eq:my_trans_01} tedy přechází do tvaru
+ o_j(t) = \frac{S_j g_j(t)}{C(t)} = S_j g_j^N \left( 1 - LC(t)^{-1} \right) .
+\end{equation} Rovnice \ref{eq:my_trans_01} tedy přechází do tvaru
 \begin{equation}\label{eq:my_trans_02}
- q_j(t+1) = q_j(t) + T \left( i_{j,0}(t) + \sum_{k \in I_j} \alpha_{k,j} S_k g_k^N \left( 1 - LC(t)^{-1} \right)  - S_j g_j^N \left( 1 - LC(t)^{-1} \right) \right)
-\end{equation}.
-Pokud budeme podobně jako v \cite{6_tuc_lq} předpokládat existenci nominální délky cyklu $C^N$, při níž se
-nemění délka fronty, platíc(
-\begin{equation}\label{eq:my_trans_nom}
- 0 = T \left( i_{j,0}(t) + \sum_{k \in I_j} \alpha_{k,j} S_k g_k^N \left( 1 - LC^{N -1} \right)  - S_j g_j^N \left( 1 - LC^{N -1} \right) \right)
-\end{equation}. Odečtením rovnice \ref{eq:my_trans_nom} od \ref{eq:my_trans_02} dostaneme
-\begin{equation}\label{eq:my_trans_03}
- q_j(t+1) = q_j(t) + T \left( - \sum_{k \in I_j} \alpha_{k,j} S_k g_k^N  + S_j g_j^N  \right) L \Delta C^{-1}(t)
-\end{equation}, kde $ \Delta C^{-1}(t) = C(t)^{-1} - C^{N -1}$. Pro ramena $j \in J_A$ náležící agentovi $A$ se
-tedy rovnice pro fronty dají zapsat maticově ve tvaru
+ q_j(t+1) = q_j(t) + T \left( i_{j,0}(t) + \sum_{k \in I_j} \alpha_{k,j} S_k g_k^N \left( 1 - LC(t)^{-1} \right)  - S_j g_j^N \left( 1 - LC(t)^{-1} \right) \right) .
+\end{equation}
+
+% Nebudeme delat trik s nominální hodnotou, ale pouzijeme u(t) = 1 - LC(t)^{-1}
+% Pokud budeme podobně jako v \cite{6_tuc_lq} předpokládat existenci nominální délky cyklu $C^N$, při níž se
+% nemění délka fronty, platíc(
+% \begin{equation}\label{eq:my_trans_nom}
+%  0 = T \left( i_{j,0}(t) + \sum_{k \in I_j} \alpha_{k,j} S_k g_k^N \left( 1 - LC^{N -1} \right)  - S_j g_j^N \left( 1 - LC^{N -1} \right) \right)
+% \end{equation}. Odečtením rovnice \ref{eq:my_trans_nom} od \ref{eq:my_trans_02} dostaneme
+% \begin{equation}\label{eq:my_trans_03}
+%  q_j(t+1) = q_j(t) + T \left( - \sum_{k \in I_j} \alpha_{k,j} S_k g_k^N  + S_j g_j^N  \right) L \Delta C^{-1}(t)
+% \end{equation}, kde $ \Delta C^{-1}(t) = C(t)^{-1} - C^{N -1}$. Pro ramena $j \in J_A$ náležící agentovi $A$ se
+% tedy rovnice pro fronty dají zapsat maticově ve tvaru
+% \begin{equation}\label{eq:my_trans_mat}
+%  \vec{q}(t+1) = A \vec{q}(t) + B \Delta C^{-1}(t) 
+% \end{equation}
+
+Za řídící proměnnou tedy vezmeme 
+\begin{equation}
+ u(t) = 1 - LC(t)^{-1} .
+\end{equation}
+takže můžeme rovnici \ref{eq:my_trans_02} přepsat do maticové formy
 \begin{equation}\label{eq:my_trans_mat}
- \vec{q}(t+1) = A \vec{q}(t) + B \Delta C^{-1}(t) 
-\end{equation}
+ q(t+1) = A q(t) + B u(t) + I_0(t) , 
+\end{equation}
+kde $A$ je jednotková matice, $B$ je diagonální matice s prvky
+\begin{equation}
+ b_{jj} =  T \left( \sum_{k \in I_j} \alpha_{k,j} S_k g_k^N - S_j g_j^N \right)
+\end{equation}
+
+
 
 Kostantni saturovany tok neni optimalni, pouzije aprox podle Pecherkove (viz bak.), 
@@ -142,13 +159,13 @@
 \end{equation}
 
-. Pokud budeme podobně jako v rovnici \ref{eq:my_trans_nom} uvažovat nominální $C^N$, pro které se $q(t+1)$ rovná $q(t)$,
-dostaneme dosazením $\Delta C^{-1}(t) = C(t)^{-1} - C^{N -1} $ do \ref{eq:my_trans_mod_tok_03} rovnici
-
-\begin{equation}\label{eq:my_trans_mod_tok_04}
-\begin{array}{ccc}
- q_j(t+1) &= q_j(t) +& L \left( \delta_j  g_j^N q_j(t)   - \sum_{k \in I_j} \alpha_{k,j} \delta_k g_k^N q_k(t) \right) C(t)^{-1} +\\
-  & & + L T \left( \delta_j i_{0,j} g_j^N - \sum_{k \in I_j} \alpha_{k,j} \delta_k i_{0,k} g_k^N  \right) C(t)^{-1} 
-\end{array} 
-\end{equation}
+% . Pokud budeme podobně jako v rovnici \ref{eq:my_trans_nom} uvažovat nominální $C^N$, pro které se $q(t+1)$ rovná $q(t)$,
+% dostaneme dosazením $\Delta C^{-1}(t) = C(t)^{-1} - C^{N -1} $ do \ref{eq:my_trans_mod_tok_03} rovnici
+% 
+% \begin{equation}\label{eq:my_trans_mod_tok_04}
+% \begin{array}{ccc}
+%  q_j(t+1) &= q_j(t) +& L \left( \delta_j  g_j^N q_j(t)   - \sum_{k \in I_j} \alpha_{k,j} \delta_k g_k^N q_k(t) \right) C(t)^{-1} +\\
+%   & & + L T \left( \delta_j i_{0,j} g_j^N - \sum_{k \in I_j} \alpha_{k,j} \delta_k i_{0,k} g_k^N  \right) C(t)^{-1} 
+% \end{array} 
+% \end{equation}
 
 
@@ -157,66 +174,104 @@
 \subsection{Minimalizační kritérium}
 Podobně jako v předchozí kapitole, minimalizovat kvaratické kritérium $J$.
-Minimalizaci budeme provádět v proměnných $\Delta C(t)$ pro časový horizont $h$,
-tedy pro vektory $\Delta C(t_0), \Delta C(t_0 + 1), ..., \Delta C(t_0 + h)$. Pro zpřehlednění
+Minimalizaci budeme provádět v proměnných $u(t)$ pro časový horizont $h$,
+tedy pro vektory $\Delta C(t_0), \Delta C(t_0 + 1), ...,u(t_0 + h)$. Pro zpřehlednění
 zápisu položíme bez újmy na obecnosti $t_0 = 0$.
 Kvadratické kritérium
 ve tvaru
 \begin{equation}\label{eq:J}
- J = \sum_{t=0}^h q(t)^T Q q(t) + \Delta C(t)^T R \Delta C(t)
-\end{equation}, 
+ J = \sum_{t=0}^h q(t)^T Q q(t) + u(t)^T R u(t) , 
+\end{equation}
 kde $Q$ a $R$ jsou diagonální pozitivně definitní matice vah,
 rozepíšeme pomocí vztahu
-\begin{equation}
- q(t+1) = Aq(t) + Bq(t)
-\end{equation} a budeme minimalizovat pro jednotlivá $t$ podle  $\Delta C(t)$.
-$\Delta C(h)$ se v kritériu vyskytuje pouze jako člen
-\begin{equation}
-\Delta C(h)^T R \Delta C(h)
-\end{equation}
-a tedy musí být $\Delta C(h) 0$. $\Delta C(h - 1)$ se vyskytuje ve tvaru
-\begin{equation}
-  \Delta C(h - 1)^T R \Delta C(h - 1) + (q(h - 1)^T A^T + \Delta C(h - 1)^T B^T ) Q ( A q(h - 1) + B \Delta C(h - 1))
+\begin{equation}\label{eq:prechod}
+ q(t+1) = Aq(t) + Bu(t) + I_0(t)
+\end{equation} 
+a budeme minimalizovat pro jednotlivá $t$ podle  $u(t)$.
+Matici $I_0(t)$, která vyjadřuje příjezd vozidel z okolí do sledované sítě,
+budeme v rámci minimalizačního horizontu považovat za konstantu značenou $I_0$.
+$u(h)$ se v kritériu vyskytuje pouze jako člen
+\begin{equation}
+u(h)^T Ru(h)
+\end{equation}
+a tedy musí být $u(h) = 0$. $u(h - 1)$ se vyskytuje ve členech
+\begin{equation}
+ u(h - 1)^T Ru(h - 1) + (q(h - 1)^T A^T +u(h - 1)^T B^T ) Q ( A q(h - 1) + B u(h - 1) + I_0)
 \end{equation}
 , což lze pomocí složených vektorů a matic přepsat do tvaru
 \begin{equation} \label{eq:J_sloz}
- (\Delta C(h-1)^T, q(h - 1)^T ) 
-  \left( \begin{array}{cc}
+ (u(h-1)^T, q(h - 1)^T ) 
+  \left( \begin{array}{cc}
+          B^T \sqrt{Q}^T & \sqrt{R}^T \\
+	  A^T \sqrt{Q}^T & 0
+	  \end{array}
+  \right)  
+  \left( \begin{array}{cc}
+           \sqrt{Q} B & \sqrt{Q} A \\
+	  \sqrt{R} & 0
+	  \end{array}
+  \right)
+  \left( \begin{array}{c}
+	   u(h-1) \\
+	    q(h - 1)
+	  \end{array}
+  \right)
+\end{equation}, kde symbolem $\sqrt{Q}$ myslíme matici, pro níž platí $\sqrt{Q}^T \sqrt{Q} = Q$.
+Matice $Q$ a $R$ jsou pozitivně definitní diagonální matice, takže $\sqrt{Q}$ bude také
+pozitivně definitní diagonální a její diagonální prvky budou rovny odmocnině
+příslušných prvků původní matice $Q$.
+Složenou matici
+\begin{equation}  
+  M_0 = \left( \begin{array}{cc}
           B^T \sqrt{Q} & \sqrt{R} \\
 	  A^T \sqrt{Q} & 0
 	  \end{array}
+  \right)   
+\end{equation}
+můžeme pomocí QR dekompozice na součin 
+
+\begin{equation}
+ M_0 = M_R M_Q ,
+\end{equation}
+kde $M_Q$ je horní trojůhelníková matice a $M_R$ je matice ortonormální.
+Pro ortonormální matici $M_R$ platí
+\begin{equation}
+ M_R^T M_R = I ,
+\end{equation}
+neboť její zloupce jsou vzájemně ortogonální a normované na jednotku.
+Z toho plyne, že součin matic $M_0^T M_0$, vyskytující se ve vztahu 
+
+Člen \ref{eq:J_sloz} poté přejde na tvar
+\begin{equation}
+ (\Delta C(h-1)^T, q(h - 1)^T ) 
+  \left( \begin{array}{cc}
+          L_q^T & 0 \\
+	  L^T & L_u^T
+	  \end{array}
   \right)  
   \left( \begin{array}{cc}
-           \sqrt{Q} B & \sqrt{Q} A \\
-	  \sqrt{R} & 0
+          L_u & L \\
+	  0 & L_q
 	  \end{array}
   \right)
   \left( \begin{array}{c}
-	    \Delta C(h-1) \\
+	   u(h-1) \\
 	    q(h - 1)
 	  \end{array}
   \right)
-\end{equation}, kde $\sqrt{Q}$ je matice, pro níž platí $\sqrt{Q} \sqrt{Q} = Q$.
-Složenou matici
-\begin{equation}
- 
-  \left( \begin{array}{cc}
-          B^T \sqrt{Q} & \sqrt{R} \\
-	  A^T \sqrt{Q} & 0
-	  \end{array}
-  \right)  
-  \left( \begin{array}{cc}
-           \sqrt{Q} B & \sqrt{Q} A \\
-	  \sqrt{R} & 0
-	  \end{array}
-  \right) = 
-  \left( \begin{array}{cc}
-          B^T Q B + R & B^T Q A \\
-	  A^T Q B & A^T Q A
-	  \end{array}
-  \right)
-\end{equation}
-můžeme pomocí Choleského dekompozici na součin dolní a horní trojúhelníkové matice.
-Rovnice 
-
+\end{equation}, který můžeme dále upravit na
+\begin{equation}
+ ( L_u u(h-1) +  L_q q(h-1) )^T ( L_uu(h-1) +  L_q q(h-1) ) + q(h-1)^T L_q^T L_q q(h-1) 
+\end{equation}. Pokud tento člen chceme minimalizovat v proměnné $q(h-1)$, musí nutně platit
+\begin{equation}
+u(h-1) = - L_u^{-1} L q(h-1)
+\end{equation}. Zbývající nenulová část $q(h-1)^T L_q^T L_q q(h-1) $ lze přepsat pomocí rovnice \ref{eq:prechod} do tvaru 
+\begin{equation}
+ q(h-1)^T L_q^T L_q q(h-1) = ( A q(h-2) + B u(h-2) )^T L_q^T L_q ( A q(h-2) + B u(h-2) )
+\end{equation}, kde se vyskytuje $u(t)$ pouze pro $t = h-2$. Minimalizace přes
+$u(h-2)$ bude probíhat analogicky, pouze se matice $Q$ nahradí maticí 
+\begin{equation}
+\widetilde{Q} = Q + L_q^T L_q
+\end{equation}, která zahrnuje zbytek po členu s $u(h-1)$.
+Pro další $u(t)$ se pouze upraví matice $\widetilde{Q}$ výše popsaným způsoen a minimalizace již probíhá stejně.\\
 
 