Index: applications/doprava/texty/novotny_vyzk_LQ/vyzk.log
===================================================================
--- applications/doprava/texty/novotny_vyzk_LQ/vyzk.log (revision 1424)
+++ applications/doprava/texty/novotny_vyzk_LQ/vyzk.log (revision 1425)
@@ -1,3 +1,3 @@
-This is pdfTeX, Version 3.1415926-1.40.10 (TeX Live 2009/Debian) (format=latex 2011.10.24)  2 FEB 2012 12:39
+This is pdfTeX, Version 3.1415926-1.40.10 (TeX Live 2009/Debian) (format=latex 2011.10.24)  3 FEB 2012 12:30
 entering extended mode
  %&-line parsing enabled.
@@ -671,4 +671,10 @@
 LaTeX Warning: Label `fig:601' multiply defined.
 
+
+LaTeX Warning: Label `fig:tc_01_007' multiply defined.
+
+
+LaTeX Warning: Label `fig:qsum_01_007' multiply defined.
+
 )
 \openout1 = `vyzk.aux'.
@@ -775,35 +781,45 @@
 Kapitola 1.
 
-Underfull \hbox (badness 10000) in paragraph at lines 3--6
-
- []
-
-
-Underfull \hbox (badness 10000) in paragraph at lines 7--13
-
- []
-
-) (./02_Agents/Agents.tex [1
-
-
-]
+Underfull \hbox (badness 10000) in paragraph at lines 3--35
+
+ []
+
+
+Underfull \hbox (badness 10000) in paragraph at lines 3--35
+
+ []
+
+
+Underfull \hbox (badness 10000) in paragraph at lines 3--35
+
+ []
+
+
+Underfull \hbox (badness 10000) in paragraph at lines 3--35
+
+ []
+
+[1
+
+
+]) (./02_Agents/Agents.tex [2]
 Kapitola 2.
 Package hyperref Info: bookmark level for unknown definition defaults to 0 on i
 nput line 22.
-[2
+[3
 
 ]
-LaTeX Font Info:    Try loading font information for OMS+cmr on input line 38.
+LaTeX Font Info:    Try loading font information for OMS+cmr on input line 34.
  (/usr/share/texmf-texlive/tex/latex/base/omscmr.fd
 File: omscmr.fd 1999/05/25 v2.5h Standard LaTeX font definitions
 )
 LaTeX Font Info:    Font shape `OMS/cmr/m/n' in size <12> not available
-(Font)              Font shape `OMS/cmsy/m/n' tried instead on input line 38.
- [3] [4]
+(Font)              Font shape `OMS/cmsy/m/n' tried instead on input line 34.
+ [4] [5]
 Kapitola 3.
-[5
+[6
 
 ]
-Overfull \hbox (4.12453pt too wide) in paragraph at lines 141--144
+Overfull \hbox (4.12453pt too wide) in paragraph at lines 137--140
 []\OT1/cmr/m/n/12 Dv^^Te strate-gie, $\OML/cmm/m/it/12 a[]$ \OT1/cmr/m/n/12 a $
 \OML/cmm/m/it/12 a[]$ \OT1/cmr/m/n/12 jsou v Nashov^^Te rovnosti, pokud
@@ -820,10 +836,10 @@
  []
 
-[6] [7]
+[7] [8]
 Underfull \hbox (badness 10000) in paragraph at lines 74--80
 
  []
 
-[8]
+[9]
 
 Package amsmath Warning: Foreign command \over;
@@ -831,5 +847,5 @@
 (amsmath)                 on input line 142.
 
-) (./Reinforcement_learning_pouziti/Reinforcement_learning_pouziti.tex [9]
+) (./Reinforcement_learning_pouziti/Reinforcement_learning_pouziti.tex [10]
 Underfull \hbox (badness 10000) in paragraph at lines 28--31
 
@@ -842,5 +858,5 @@
  []
 
-[10]) (./03_RMM/RMM.tex [11]
+[11]) (./03_RMM/RMM.tex [12]
 Overfull \hbox (31.25705pt too wide) in paragraph at lines 37--38
 []\OT1/cmr/m/n/12 Rekursivn^^S^^P mod-e-lov^^Sa struk-tura $\OML/cmm/m/it/12 RM
@@ -852,5 +868,5 @@
 (Font)              size <6> substituted on input line 52.
 
-[12]
+[13]
 Underfull \hbox (badness 10000) in paragraph at lines 72--76
 
@@ -873,5 +889,5 @@
  []
 
-[13]) (./04_Bayes/Bayes.tex
+[14]) (./04_Bayes/Bayes.tex
 Overfull \hbox (2.46631pt too wide) in paragraph at lines 4--12
 \OT1/cmr/m/n/12 V t^^Seto kapi-tole je nazna^^Tcena metoda bayesovsk^^Seho u^^T
@@ -881,10 +897,10 @@
 Package hyperref Info: bookmark level for unknown proposition defaults to 0 on 
 input line 19.
-[14]) (./06_Bayes_rmm_pouziti/Bayes_rmm_pouziti.tex
+[15]) (./06_Bayes_rmm_pouziti/Bayes_rmm_pouziti.tex
 Underfull \hbox (badness 10000) in paragraph at lines 5--9
 
  []
 
-[15]
+[16]
 Overfull \hbox (6.66295pt too wide) in paragraph at lines 10--17
 \OML/cmm/m/it/12 R[]; R[]$ \OT1/cmr/m/n/12 ovl^^Sadal jednu z nich. K mod-e-lov
@@ -904,5 +920,5 @@
 (Font)              size <10> substituted on input line 30.
 
-[16]
+[17]
 File: ./06_Bayes_rmm_pouziti/rmm_results.eps Graphic file (type eps)
  <./06_Bayes_rmm_pouziti/rmm_results.eps>) (./LQ_rizeni.tex
@@ -924,5 +940,5 @@
  []
 
-[17]
+[18]
 Overfull \hbox (0.73724pt too wide) in paragraph at lines 37--42
 \OT1/cmr/m/n/12 LQ ^^Tr^^S^^Pzen^^S^^P bylo pou^^Tzito v [[]] k nalezen^^S^^P o
@@ -930,5 +946,5 @@
  []
 
-[18]
+[19]
 Overfull \hbox (10.17679pt too wide) in paragraph at lines 97--101
 \OT1/cmr/m/n/12 zm^^Tenu d^^Selky trv^^San^^S^^P ze-len^^Se oproti nomin^^Saln^
@@ -936,5 +952,5 @@
  []
 
-[19]) (./Implementation/Implementation.tex [20]
+[20]) (./Implementation/Implementation.tex [21]
 Kapitola 4.
 
@@ -968,5 +984,5 @@
  []
 
-[21
+[22
 
 ]
@@ -974,19 +990,9 @@
 
 
-[22] [23] (./Implementation/Minimalization.tex
-Overfull \hbox (17.17238pt too wide) in paragraph at lines 2--9
-\OT1/cmr/m/n/12 budeme prov^^Sad^^Tet v prom^^Tenn^^Sych $\OML/cmm/m/it/12 u\OT
-1/cmr/m/n/12 (\OML/cmm/m/it/12 t\OT1/cmr/m/n/12 )$ pro ^^Tcasov^^Sy hor-i-zont 
-$\OML/cmm/m/it/12 h$\OT1/cmr/m/n/12 , tedy pro vek-tory $^^A\OML/cmm/m/it/12 C\
-OT1/cmr/m/n/12 (\OML/cmm/m/it/12 t[]\OT1/cmr/m/n/12 )\OML/cmm/m/it/12 ; \OT1/cm
-r/m/n/12 ^^A\OML/cmm/m/it/12 C\OT1/cmr/m/n/12 (\OML/cmm/m/it/12 t[] \OT1/cmr/m/
-n/12 +
- []
-
-[24]
-
-LaTeX Warning: Reference `eq:prechod' on page 25 undefined on input line 128.
-
-[25] [26]
+[23] [24] (./Implementation/Minimalization.tex [25]
+
+LaTeX Warning: Reference `eq:prechod' on page 26 undefined on input line 128.
+
+[26] [27]
 Overfull \hbox (33.4813pt too wide) in paragraph at lines 191--192
 [][][][][][][][][][][][][][][][][][][][][][][][][] 
@@ -1016,5 +1022,5 @@
  []
 
-[27]
+[28]
 Underfull \hbox (badness 10000) in paragraph at lines 99--123
 
@@ -1026,24 +1032,38 @@
  []
 
-[28]
+[29]
 File: Implementation/fig/601.eps Graphic file (type eps)
  <Implementation/fig/601.eps>
 File: Implementation/fig/495.eps Graphic file (type eps)
- <Implementation/fig/495.eps> [29]
+ <Implementation/fig/495.eps> [30]
 Underfull \hbox (badness 10000) in paragraph at lines 155--172
 
  []
 
-) (./Results.tex [30]
+(./Implementation/ChangingFlow.tex [31]
+Underfull \hbox (badness 10000) in paragraph at lines 43--54
+
+ []
+
+[32])) (./Results/Results.tex [33]
 Kapitola 5.
-) (./Ending.tex [31
+File: Results/fig/tc_01_007.eps Graphic file (type eps)
+<Results/fig/tc_01_007.eps> [34
 
 ]
+File: Results/fig/qsum_01_007.eps Graphic file (type eps)
+ <Results/fig/qsum_01_007.eps> [35]
+File: Results/fig/01/a_numStops.eps Graphic file (type eps)
+
+<Results/fig/01/a_numStops.eps>
+File: Results/fig/01/a_travelTimeAvg.eps Graphic file (type eps)
+ <Results/fig/01/a_travelTimeAvg.eps>)
+(./Ending.tex [36] [37]
 Kapitola 6.
-) (./vyzk.bbl [32
-
-] [33
-
-]) [34] (./Appendix//01.tex
+) (./vyzk.bbl [38
+
+] [39
+
+]) [40] (./Appendix//01.tex
 P\v {r}\'{\i }loha A.
 )
@@ -1067,11 +1087,11 @@
  ) 
 Here is how much of TeX's memory you used:
- 10588 strings out of 495062
- 143948 string characters out of 1182643
- 232294 words of memory out of 3000000
- 13518 multiletter control sequences out of 15000+50000
+ 10614 strings out of 495062
+ 144408 string characters out of 1182643
+ 231594 words of memory out of 3000000
+ 13534 multiletter control sequences out of 15000+50000
  17737 words of font info for 73 fonts, out of 3000000 for 9000
  29 hyphenation exceptions out of 8191
  43i,11n,45p,276b,1730s stack positions out of 5000i,500n,10000p,200000b,50000s
 
-Output written on vyzk.dvi (42 pages, 192848 bytes).
+Output written on vyzk.dvi (48 pages, 211484 bytes).