Index: applications/doprava/texty/novotny_vyzk_LQ/vyzk.log
===================================================================
--- applications/doprava/texty/novotny_vyzk_LQ/vyzk.log (revision 1427)
+++ applications/doprava/texty/novotny_vyzk_LQ/vyzk.log (revision 1428)
@@ -1,3 +1,3 @@
-This is pdfTeX, Version 3.1415926-1.40.10 (TeX Live 2009/Debian) (format=latex 2011.10.24)  3 FEB 2012 14:39
+This is pdfTeX, Version 3.1415926-1.40.10 (TeX Live 2009/Debian) (format=latex 2011.10.24)  3 FEB 2012 14:52
 entering extended mode
  %&-line parsing enabled.
@@ -667,15 +667,5 @@
     [onewside].
 
-(./vyzk.aux
-
-LaTeX Warning: Label `fig:601' multiply defined.
-
-
-LaTeX Warning: Label `fig:tc_01_007' multiply defined.
-
-
-LaTeX Warning: Label `fig:qsum_01_007' multiply defined.
-
-)
+(./vyzk.aux)
 \openout1 = `vyzk.aux'.
 
@@ -771,12 +761,12 @@
 ] [4
 
-] (./vyzk.toc [5
-
-
-])
+] (./vyzk.toc)
 \tf@toc=\write4
 \openout4 = `vyzk.toc'.
 
- [6] (./01_Intro/Intro.tex
+ [5
+
+
+] (./01_Intro/Intro.tex
 Kapitola 1.
 
@@ -803,297 +793,27 @@
 
 
-]) (./MatematicMethods/MatematicMethods.tex [2]
-Kapitola 2.
-Package hyperref Info: bookmark level for unknown definition defaults to 0 on i
-nput line 22.
-[3
-
-]
-LaTeX Font Info:    Try loading font information for OMS+cmr on input line 34.
- (/usr/share/texmf-texlive/tex/latex/base/omscmr.fd
-File: omscmr.fd 1999/05/25 v2.5h Standard LaTeX font definitions
-)
-LaTeX Font Info:    Font shape `OMS/cmr/m/n' in size <12> not available
-(Font)              Font shape `OMS/cmsy/m/n' tried instead on input line 34.
- [4] [5]
-Overfull \hbox (4.12453pt too wide) in paragraph at lines 134--137
-[]\OT1/cmr/m/n/12 Dv^^Te strate-gie, $\OML/cmm/m/it/12 a[]$ \OT1/cmr/m/n/12 a $
-\OML/cmm/m/it/12 a[]$ \OT1/cmr/m/n/12 jsou v Nashov^^Te rovnosti, pokud
- []
-
-) (./Reinforcement_learning.tex
-Underfull \hbox (badness 10000) in paragraph at lines 4--10
-
- []
-
-
-Overfull \hbox (3.37529pt too wide) in paragraph at lines 17--18
-[]\OT1/cmr/m/n/12 Markov^^Wuv rozhodovac^^S^^P pro-ces je defi-
- []
-
-[6] [7]
-Underfull \hbox (badness 10000) in paragraph at lines 74--80
-
- []
-
-[8]
-
-Package amsmath Warning: Foreign command \over;
-(amsmath)                \frac or \genfrac should be used instead
-(amsmath)                 on input line 142.
-
-[9]) (./03_RMM/RMM.tex
-Overfull \hbox (31.25705pt too wide) in paragraph at lines 37--38
-[]\OT1/cmr/m/n/12 Rekursivn^^S^^P mod-e-lov^^Sa struk-tura $\OML/cmm/m/it/12 RM
-S[]$
- []
-
-[10]
-
-LaTeX Font Warning: Font shape `OT1/mnozina/m/n' in size <5> not available
-(Font)              size <6> substituted on input line 52.
-
-
-Underfull \hbox (badness 10000) in paragraph at lines 72--76
-
- []
-
-
-Underfull \hbox (badness 10000) in paragraph at lines 77--81
-
- []
-
-[11]
-Underfull \hbox (badness 10000) in paragraph at lines 82--84
-
- []
-
-
-Overfull \hbox (5.1121pt too wide) in paragraph at lines 91--94
-\OT1/cmr/m/n/12 Po zkon-struov^^San^^S^^P rekurzivn^^S^^P mod-e-lov^^Se struk-t
-ury se proch^^Saz^^S^^P tento syst^^Sem od konce rekurze,
- []
-
-) (./04_Bayes/Bayes.tex
-Overfull \hbox (2.46631pt too wide) in paragraph at lines 4--12
-\OT1/cmr/m/n/12 V t^^Seto kapi-tole je nazna^^Tcena metoda bayesovsk^^Seho u^^T
-cen^^S^^P , co^^Tz je bodov^^Sy odhadu parametru
- []
-
-[12]
-Package hyperref Info: bookmark level for unknown proposition defaults to 0 on 
-input line 19.
- [13]) (./LQ_rizeni.tex
-Overfull \hbox (9.84808pt too wide) in paragraph at lines 3--9
-\OT1/cmr/m/n/12 obecn^^Te o metodu, kdy je syst^^Sem v diskr^^Setn^^S^^Pm ^^Tca
-sov^^Sem kroku $\OML/cmm/m/it/12 t$ \OT1/cmr/m/n/12 pops^^San vek-torem prom^^T
-enn^^Sych
- []
-
-
-Overfull \hbox (1.58498pt too wide) in paragraph at lines 3--9
-\OML/cmm/m/it/12 x\OT1/cmr/m/n/12 (\OML/cmm/m/it/12 t\OT1/cmr/m/n/12 ) = (\OML/
-cmm/m/it/12 x[]\OT1/cmr/m/n/12 (\OML/cmm/m/it/12 t\OT1/cmr/m/n/12 )\OML/cmm/m/i
-t/12 ; :::; x[]\OT1/cmr/m/n/12 (\OML/cmm/m/it/12 t\OT1/cmr/m/n/12 ))$ a my m^^W
-u^^Tzeme nas-tavo-vat vek-tor parametr^^Wu $\OML/cmm/m/it/12 y\OT1/cmr/m/n/12 (
-\OML/cmm/m/it/12 t\OT1/cmr/m/n/12 ) = (\OML/cmm/m/it/12 y[]\OT1/cmr/m/n/12 (\OM
-L/cmm/m/it/12 t\OT1/cmr/m/n/12 )\OML/cmm/m/it/12 ; :::; y[]\OT1/cmr/m/n/12 (\OM
-L/cmm/m/it/12 t\OT1/cmr/m/n/12 ))$.
- []
-
-[14]) (./Pouziti/Pouziti.tex [15]
-Kapitola 3.
-(./Reinforcement_learning_pouziti/Reinforcement_learning_pouziti.tex [16
-
-]
-Underfull \hbox (badness 10000) in paragraph at lines 26--29
-
- []
-
-) (./06_Bayes_rmm_pouziti/Bayes_rmm_pouziti.tex
-Underfull \hbox (badness 10000) in paragraph at lines 5--9
-
- []
-
-
-Overfull \hbox (6.66295pt too wide) in paragraph at lines 10--17
-\OML/cmm/m/it/12 R[]; R[]$ \OT1/cmr/m/n/12 ovl^^Sadal jednu z nich. K mod-e-lov
-^^San^^S^^P chov^^San^^S^^P druh^^Seho agenta bylo pou^^Tzito t^^Tr^^S^^Psyup^^
-Tnov^^Se
- []
-
-
-Underfull \hbox (badness 10000) in paragraph at lines 10--17
-
- []
-
-File: ./06_Bayes_rmm_pouziti/rmm_structure.eps Graphic file (type eps)
-<./06_Bayes_rmm_pouziti/rmm_structure.eps>
-
-LaTeX Font Warning: Font shape `OT1/mnozina/m/n' in size <10.95> not available
-(Font)              size <10> substituted on input line 30.
-
-[17] [18]
-File: ./06_Bayes_rmm_pouziti/rmm_results.eps Graphic file (type eps)
- <./06_Bayes_rmm_pouziti/rmm_results.eps>)
-Overfull \hbox (22.51053pt too wide) in paragraph at lines 12--29
-\OT1/cmr/m/n/12 kter^^Se jsou pro sim-u-laci po dlouhou dobu op-ti-mal-i-zov^^S
-any a je-jich^^Tz nasazen^^S^^P zna^^Tcn^^Te zjednodu^^Tsuje
- []
-
-[19]
-Overfull \hbox (0.73724pt too wide) in paragraph at lines 39--44
-\OT1/cmr/m/n/12 LQ ^^Tr^^S^^Pzen^^S^^P bylo pou^^Tzito v [[]] k nalezen^^S^^P o
-p-tim^^Saln^^S^^P d^^Selky ze-len^^Sych v syst^^Semu 13-ti sign^^Saln^^S^^Pch
- []
-
-[20]
-Overfull \hbox (10.17679pt too wide) in paragraph at lines 101--105
-\OT1/cmr/m/n/12 zm^^Tenu d^^Selky trv^^San^^S^^P ze-len^^Se oproti nomin^^Saln^
-^S^^Pm hod-not^^Sam. Kvadrat-ick^^Se krit^^Serium op-tim^^Saln^^S^^Pho
- []
-
-[21]) (./Implementation/Implementation.tex [22]
-Kapitola 4.
-
-Underfull \hbox (badness 3954) in paragraph at lines 16--17
-[]|\OT1/cmr/m/n/12 Maxim^^Saln^^S^^P po^^Tcet vozidel,
- []
-
-
-Underfull \hbox (badness 1237) in paragraph at lines 17--18
-[]|[]\OT1/cmr/m/n/12 Cas pot^^Trebn^^Sy k vyk-l-izen^^S^^P
- []
-
-
-Underfull \hbox (badness 10000) in paragraph at lines 17--18
-\OT1/cmr/m/n/12 k^^Tri^^Tzovatky mezi dv^^Tema
- []
-
-
-Underfull \hbox (badness 2452) in paragraph at lines 19--20
-[]|\OT1/cmr/m/n/12 Skupiny n^^Sale^^Tz^^S^^Pc^^S^^P jed-nomu
- []
-
-
-Underfull \hbox (badness 6995) in paragraph at lines 20--20
-[]|\OT1/cmr/m/n/12 Mno^^Tzina vstup^^Wu sign^^Saln^^S^^P
- []
-
-
-Overfull \hbox (27.91731pt too wide) in paragraph at lines 12--28
-[] 
- []
-
-[23
-
-]
-Overfull \vbox (54.37534pt too high) has occurred while \output is active []
-
-
-[24] [25] (./Implementation/Minimalization.tex [26]
-
-LaTeX Warning: Reference `eq:prechod' on page 27 undefined on input line 128.
-
-[27] [28]
-Overfull \hbox (33.4813pt too wide) in paragraph at lines 191--192
-[][][][][][][][][][][][][][][][][][][][][][][][][] 
- []
-
-LaTeX Font Info:    Try loading font information for OML+cmr on input line 195.
-
-(/usr/share/texmf-texlive/tex/latex/base/omlcmr.fd
-File: omlcmr.fd 1999/05/25 v2.5h Standard LaTeX font definitions
-)
-LaTeX Font Info:    Font shape `OML/cmr/m/n' in size <12> not available
-(Font)              Font shape `OML/cmm/m/it' tried instead on input line 195.
-
-Overfull \hbox (5.28134pt too wide) in paragraph at lines 207--208
-[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][] 
- []
-
-)
-Underfull \hbox (badness 10000) in paragraph at lines 81--97
-
- []
-
-
-Overfull \hbox (6.58554pt too wide) in paragraph at lines 81--97
-\OT1/cmr/m/n/12 pl^^San^^Wu ^^Tr^^S^^Pzen^^S^^P do-pravy, po^^Tzadovan^^Sych do
--pravn^^S^^Pch data, a pl^^San^^Wu hro-madn^^Se do-pravy a mno^^Tzinu
- []
-
-[29]
-Underfull \hbox (badness 10000) in paragraph at lines 99--123
-
- []
-
-
-Underfull \hbox (badness 10000) in paragraph at lines 99--123
-
- []
-
-[30]
-File: Implementation/fig/601.eps Graphic file (type eps)
- <Implementation/fig/601.eps>
-File: Implementation/fig/495.eps Graphic file (type eps)
- <Implementation/fig/495.eps> [31]
-Underfull \hbox (badness 10000) in paragraph at lines 155--172
-
- []
-
-(./Implementation/ChangingFlow.tex [32]
-Underfull \hbox (badness 10000) in paragraph at lines 43--54
-
- []
-
-[33])) (./Results/Results.tex [34]
-Kapitola 5.
-File: Results/fig/tc_01_007.eps Graphic file (type eps)
-<Results/fig/tc_01_007.eps> [35
-
-]
-File: Results/fig/qsum_01_007.eps Graphic file (type eps)
- <Results/fig/qsum_01_007.eps> [36]
-File: Results/fig/01/a_numStops.eps Graphic file (type eps)
-
-<Results/fig/01/a_numStops.eps>
-File: Results/fig/01/a_travelTimeAvg.eps Graphic file (type eps)
- <Results/fig/01/a_travelTimeAvg.eps>)
-(./Ending.tex [37] [38]
-Kapitola 6.
-) (./vyzk.bbl [39
-
-] [40
-
-]) [41] (./Appendix//01.tex
-P\v {r}\'{\i }loha A.
-)
-\tf@thm=\write5
-\openout5 = `vyzk.thm'.
-
- [1
-
-
-] (./vyzk.aux)
-
-LaTeX Font Warning: Size substitutions with differences
-(Font)              up to 2.4pt have occurred.
-
-
-LaTeX Warning: There were undefined references.
-
-
-LaTeX Warning: There were multiply-defined labels.
-
- ) 
+])
+
+! LaTeX Error: File `MathematicalMethods/MathematicalMethods.tex' not found.
+
+Type X to quit or <RETURN> to proceed,
+or enter new name. (Default extension: tex)
+
+Enter file name: 
+! Emergency stop.
+<read *> 
+         
+l.121 ...hematicalMethods/MathematicalMethods.tex}
+                                                  ^^M
+*** (cannot \read from terminal in nonstop modes)
+
+ 
 Here is how much of TeX's memory you used:
- 10619 strings out of 495062
- 144524 string characters out of 1182643
- 231586 words of memory out of 3000000
- 13535 multiletter control sequences out of 15000+50000
- 17737 words of font info for 73 fonts, out of 3000000 for 9000
+ 10061 strings out of 495062
+ 137956 string characters out of 1182643
+ 216004 words of memory out of 3000000
+ 13056 multiletter control sequences out of 15000+50000
+ 13551 words of font info for 56 fonts, out of 3000000 for 9000
  29 hyphenation exceptions out of 8191
- 43i,11n,45p,276b,1730s stack positions out of 5000i,500n,10000p,200000b,50000s
-
-Output written on vyzk.dvi (49 pages, 213264 bytes).
+ 43i,10n,45p,276b,399s stack positions out of 5000i,500n,10000p,200000b,50000s
+Output written on vyzk.dvi (7 pages, 13712 bytes).